/**
 */
package org.eclipse.incquery.tooling.generator.model.generatorModel;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see org.eclipse.incquery.tooling.generator.model.generatorModel.GeneratorModelFactory
 * @model kind="package"
 * @generated
 */
public interface GeneratorModelPackage extends EPackage
{
  /**
   * The package name.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String eNAME = "generatorModel";

  /**
   * The package namespace URI.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String eNS_URI = "http://www.eclipse.org/incquery/tooling/generator/model/IQGenModel";

  /**
   * The package namespace name.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String eNS_PREFIX = "generatorModel";

  /**
   * The singleton instance of the package.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  GeneratorModelPackage eINSTANCE = org.eclipse.incquery.tooling.generator.model.generatorModel.impl.GeneratorModelPackageImpl.init();

  /**
   * The meta object id for the '{@link org.eclipse.incquery.tooling.generator.model.generatorModel.impl.IncQueryGeneratorModelImpl <em>Inc Query Generator Model</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see org.eclipse.incquery.tooling.generator.model.generatorModel.impl.IncQueryGeneratorModelImpl
   * @see org.eclipse.incquery.tooling.generator.model.generatorModel.impl.GeneratorModelPackageImpl#getIncQueryGeneratorModel()
   * @generated
   */
  int INC_QUERY_GENERATOR_MODEL = 0;

  /**
   * The feature id for the '<em><b>Genmodels</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int INC_QUERY_GENERATOR_MODEL__GENMODELS = 0;

  /**
   * The feature id for the '<em><b>Configuration</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int INC_QUERY_GENERATOR_MODEL__CONFIGURATION = 1;

  /**
   * The number of structural features of the '<em>Inc Query Generator Model</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int INC_QUERY_GENERATOR_MODEL_FEATURE_COUNT = 2;

  /**
   * The meta object id for the '{@link org.eclipse.incquery.tooling.generator.model.generatorModel.impl.GeneratorModelReferenceImpl <em>Reference</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see org.eclipse.incquery.tooling.generator.model.generatorModel.impl.GeneratorModelReferenceImpl
   * @see org.eclipse.incquery.tooling.generator.model.generatorModel.impl.GeneratorModelPackageImpl#getGeneratorModelReference()
   * @generated
   */
  int GENERATOR_MODEL_REFERENCE = 1;

  /**
   * The feature id for the '<em><b>Genmodel</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int GENERATOR_MODEL_REFERENCE__GENMODEL = 0;

  /**
   * The number of structural features of the '<em>Reference</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int GENERATOR_MODEL_REFERENCE_FEATURE_COUNT = 1;

  /**
   * The meta object id for the '{@link org.eclipse.incquery.tooling.generator.model.generatorModel.impl.ConfigurationImpl <em>Configuration</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see org.eclipse.incquery.tooling.generator.model.generatorModel.impl.ConfigurationImpl
   * @see org.eclipse.incquery.tooling.generator.model.generatorModel.impl.GeneratorModelPackageImpl#getConfiguration()
   * @generated
   */
  int CONFIGURATION = 2;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int CONFIGURATION__NAME = 0;

  /**
   * The feature id for the '<em><b>Property</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int CONFIGURATION__PROPERTY = 1;

  /**
   * The number of structural features of the '<em>Configuration</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int CONFIGURATION_FEATURE_COUNT = 2;

  /**
   * The meta object id for the '{@link org.eclipse.incquery.tooling.generator.model.generatorModel.impl.PropertyImpl <em>Property</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see org.eclipse.incquery.tooling.generator.model.generatorModel.impl.PropertyImpl
   * @see org.eclipse.incquery.tooling.generator.model.generatorModel.impl.GeneratorModelPackageImpl#getProperty()
   * @generated
   */
  int PROPERTY = 3;

  /**
   * The feature id for the '<em><b>Key</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PROPERTY__KEY = 0;

  /**
   * The feature id for the '<em><b>Value</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PROPERTY__VALUE = 1;

  /**
   * The number of structural features of the '<em>Property</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PROPERTY_FEATURE_COUNT = 2;


  /**
   * Returns the meta object for class '{@link org.eclipse.incquery.tooling.generator.model.generatorModel.IncQueryGeneratorModel <em>Inc Query Generator Model</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Inc Query Generator Model</em>'.
   * @see org.eclipse.incquery.tooling.generator.model.generatorModel.IncQueryGeneratorModel
   * @generated
   */
  EClass getIncQueryGeneratorModel();

  /**
   * Returns the meta object for the containment reference list '{@link org.eclipse.incquery.tooling.generator.model.generatorModel.IncQueryGeneratorModel#getGenmodels <em>Genmodels</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference list '<em>Genmodels</em>'.
   * @see org.eclipse.incquery.tooling.generator.model.generatorModel.IncQueryGeneratorModel#getGenmodels()
   * @see #getIncQueryGeneratorModel()
   * @generated
   */
  EReference getIncQueryGeneratorModel_Genmodels();

  /**
   * Returns the meta object for the containment reference list '{@link org.eclipse.incquery.tooling.generator.model.generatorModel.IncQueryGeneratorModel#getConfiguration <em>Configuration</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference list '<em>Configuration</em>'.
   * @see org.eclipse.incquery.tooling.generator.model.generatorModel.IncQueryGeneratorModel#getConfiguration()
   * @see #getIncQueryGeneratorModel()
   * @generated
   */
  EReference getIncQueryGeneratorModel_Configuration();

  /**
   * Returns the meta object for class '{@link org.eclipse.incquery.tooling.generator.model.generatorModel.GeneratorModelReference <em>Reference</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Reference</em>'.
   * @see org.eclipse.incquery.tooling.generator.model.generatorModel.GeneratorModelReference
   * @generated
   */
  EClass getGeneratorModelReference();

  /**
   * Returns the meta object for the reference '{@link org.eclipse.incquery.tooling.generator.model.generatorModel.GeneratorModelReference#getGenmodel <em>Genmodel</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the reference '<em>Genmodel</em>'.
   * @see org.eclipse.incquery.tooling.generator.model.generatorModel.GeneratorModelReference#getGenmodel()
   * @see #getGeneratorModelReference()
   * @generated
   */
  EReference getGeneratorModelReference_Genmodel();

  /**
   * Returns the meta object for class '{@link org.eclipse.incquery.tooling.generator.model.generatorModel.Configuration <em>Configuration</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Configuration</em>'.
   * @see org.eclipse.incquery.tooling.generator.model.generatorModel.Configuration
   * @generated
   */
  EClass getConfiguration();

  /**
   * Returns the meta object for the attribute '{@link org.eclipse.incquery.tooling.generator.model.generatorModel.Configuration#getName <em>Name</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Name</em>'.
   * @see org.eclipse.incquery.tooling.generator.model.generatorModel.Configuration#getName()
   * @see #getConfiguration()
   * @generated
   */
  EAttribute getConfiguration_Name();

  /**
   * Returns the meta object for the containment reference list '{@link org.eclipse.incquery.tooling.generator.model.generatorModel.Configuration#getProperty <em>Property</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference list '<em>Property</em>'.
   * @see org.eclipse.incquery.tooling.generator.model.generatorModel.Configuration#getProperty()
   * @see #getConfiguration()
   * @generated
   */
  EReference getConfiguration_Property();

  /**
   * Returns the meta object for class '{@link org.eclipse.incquery.tooling.generator.model.generatorModel.Property <em>Property</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Property</em>'.
   * @see org.eclipse.incquery.tooling.generator.model.generatorModel.Property
   * @generated
   */
  EClass getProperty();

  /**
   * Returns the meta object for the attribute '{@link org.eclipse.incquery.tooling.generator.model.generatorModel.Property#getKey <em>Key</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Key</em>'.
   * @see org.eclipse.incquery.tooling.generator.model.generatorModel.Property#getKey()
   * @see #getProperty()
   * @generated
   */
  EAttribute getProperty_Key();

  /**
   * Returns the meta object for the attribute '{@link org.eclipse.incquery.tooling.generator.model.generatorModel.Property#getValue <em>Value</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Value</em>'.
   * @see org.eclipse.incquery.tooling.generator.model.generatorModel.Property#getValue()
   * @see #getProperty()
   * @generated
   */
  EAttribute getProperty_Value();

  /**
   * Returns the factory that creates the instances of the model.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the factory that creates the instances of the model.
   * @generated
   */
  GeneratorModelFactory getGeneratorModelFactory();

  /**
   * <!-- begin-user-doc -->
   * Defines literals for the meta objects that represent
   * <ul>
   *   <li>each class,</li>
   *   <li>each feature of each class,</li>
   *   <li>each enum,</li>
   *   <li>and each data type</li>
   * </ul>
   * <!-- end-user-doc -->
   * @generated
   */
  interface Literals
  {
    /**
     * The meta object literal for the '{@link org.eclipse.incquery.tooling.generator.model.generatorModel.impl.IncQueryGeneratorModelImpl <em>Inc Query Generator Model</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see org.eclipse.incquery.tooling.generator.model.generatorModel.impl.IncQueryGeneratorModelImpl
     * @see org.eclipse.incquery.tooling.generator.model.generatorModel.impl.GeneratorModelPackageImpl#getIncQueryGeneratorModel()
     * @generated
     */
    EClass INC_QUERY_GENERATOR_MODEL = eINSTANCE.getIncQueryGeneratorModel();

    /**
     * The meta object literal for the '<em><b>Genmodels</b></em>' containment reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference INC_QUERY_GENERATOR_MODEL__GENMODELS = eINSTANCE.getIncQueryGeneratorModel_Genmodels();

    /**
     * The meta object literal for the '<em><b>Configuration</b></em>' containment reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference INC_QUERY_GENERATOR_MODEL__CONFIGURATION = eINSTANCE.getIncQueryGeneratorModel_Configuration();

    /**
     * The meta object literal for the '{@link org.eclipse.incquery.tooling.generator.model.generatorModel.impl.GeneratorModelReferenceImpl <em>Reference</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see org.eclipse.incquery.tooling.generator.model.generatorModel.impl.GeneratorModelReferenceImpl
     * @see org.eclipse.incquery.tooling.generator.model.generatorModel.impl.GeneratorModelPackageImpl#getGeneratorModelReference()
     * @generated
     */
    EClass GENERATOR_MODEL_REFERENCE = eINSTANCE.getGeneratorModelReference();

    /**
     * The meta object literal for the '<em><b>Genmodel</b></em>' reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference GENERATOR_MODEL_REFERENCE__GENMODEL = eINSTANCE.getGeneratorModelReference_Genmodel();

    /**
     * The meta object literal for the '{@link org.eclipse.incquery.tooling.generator.model.generatorModel.impl.ConfigurationImpl <em>Configuration</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see org.eclipse.incquery.tooling.generator.model.generatorModel.impl.ConfigurationImpl
     * @see org.eclipse.incquery.tooling.generator.model.generatorModel.impl.GeneratorModelPackageImpl#getConfiguration()
     * @generated
     */
    EClass CONFIGURATION = eINSTANCE.getConfiguration();

    /**
     * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute CONFIGURATION__NAME = eINSTANCE.getConfiguration_Name();

    /**
     * The meta object literal for the '<em><b>Property</b></em>' containment reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference CONFIGURATION__PROPERTY = eINSTANCE.getConfiguration_Property();

    /**
     * The meta object literal for the '{@link org.eclipse.incquery.tooling.generator.model.generatorModel.impl.PropertyImpl <em>Property</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see org.eclipse.incquery.tooling.generator.model.generatorModel.impl.PropertyImpl
     * @see org.eclipse.incquery.tooling.generator.model.generatorModel.impl.GeneratorModelPackageImpl#getProperty()
     * @generated
     */
    EClass PROPERTY = eINSTANCE.getProperty();

    /**
     * The meta object literal for the '<em><b>Key</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute PROPERTY__KEY = eINSTANCE.getProperty_Key();

    /**
     * The meta object literal for the '<em><b>Value</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute PROPERTY__VALUE = eINSTANCE.getProperty_Value();

  }

} //GeneratorModelPackage
